import mongoose from "mongoose";
import {IDrink} from "./IDrink";
import {IIngredient} from "./IIngredient";
import {IContainer} from "./IContainer";

export interface IJob extends mongoose.Document {
    drink: IDrink;
    amounts: { ingredient: IIngredient, amount: number, container: IContainer }[];
    completeAmount: number
    startedAt: Date;
    endAt: Date;
    estimatedTime : number;
    successful: boolean;
}